using Amazon.Lambda.Core;

// Assembly attribute to enable the Lambda function's JSON input to be converted into a .NET class.
[assembly: LambdaSerializer(typeof(Amazon.Lambda.Serialization.SystemTextJson.DefaultLambdaJsonSerializer))]

namespace LambdaFunctionProvisionedConcurrency;

public class Function
{
    private readonly string _functionId;
    private readonly string _functionCreationTime; 

    public Function()
    {
        Console.WriteLine("Starting slow constructor");
        Task.Delay(5000).GetAwaiter().GetResult();
        _functionId = Guid.NewGuid().ToString(); 
        _functionCreationTime = DateTime.Now.ToString("HH:mm:ss.fff");
        Console.WriteLine("Finishing slow constructor");
    }

    public Response FunctionHandler(ILambdaContext context)
    {
        Response response = new Response() 
        {
            FunctionId = _functionId,
            FunctionCreationTime = _functionCreationTime,
            FunctionInvocationTime = DateTime.Now.ToString("HH:mm:ss.fff"),
            ARN = context.InvokedFunctionArn
        };

        return response;
    }
}

public class Response
{
    public string FunctionId { get; set; }
    public string FunctionCreationTime { get; set; } 
    public string FunctionInvocationTime { get; set; }  
    public string ARN { get; set; } 
}
